// LSysDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Lse.h"
#include "LSysDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLSysDlg dialog


CLSysDlg::CLSysDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLSysDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLSysDlg)
	m_pszAxiom = _T("");
	m_pszRule = _T("");
	m_fStepSize = 0.0f;
	m_fInitAngle = 0.0f;
	m_fAngle = 0.0f;
	m_iSegment = 0;
	m_pszName = _T("");
	//}}AFX_DATA_INIT
}


void CLSysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLSysDlg)
	DDX_Control(pDX, IDC_RULELIST, m_cRuleList);
	DDX_Text(pDX, IDC_AXIOM, m_pszAxiom);
	DDX_Text(pDX, IDC_RULE, m_pszRule);
	DDX_Text(pDX, IDC_STEPSIZE, m_fStepSize);
	DDV_MinMaxFloat(pDX, m_fStepSize, 0.f, 1.f);
	DDX_Text(pDX, IDC_INITANGLE, m_fInitAngle);
	DDV_MinMaxFloat(pDX, m_fInitAngle, 0.f, 359.f);
	DDX_Text(pDX, IDC_ANGLE, m_fAngle);
	DDV_MinMaxFloat(pDX, m_fAngle, 0.f, 359.f);
	DDX_Text(pDX, IDC_SEGMENT, m_iSegment);
	DDV_MinMaxUInt(pDX, m_iSegment, 1, 1024);
	DDX_Text(pDX, IDC_NAME, m_pszName);
	DDV_MaxChars(pDX, m_pszName, 1024);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLSysDlg, CDialog)
	//{{AFX_MSG_MAP(CLSysDlg)
	ON_CBN_SELENDOK(IDC_RULELIST, OnSelEndOkRulelist)
	ON_EN_CHANGE(IDC_RULE, OnChangeRule)
	ON_EN_CHANGE(IDC_NAME, OnChangeName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLSysDlg message handlers

void CLSysDlg::SetAxiomAndRules(CString *pAxiom, CString *pRules, float *angle)
{
	m_pAxiom  = pAxiom;
	m_pRules  = pRules;
	m_pfAngle = angle;

	m_pszAxiom = *pAxiom;
	m_fAngle   = *angle;
}

void CLSysDlg::SetName(CString *name)
{
	m_pName = name;
	m_pszName = *name;
}

void CLSysDlg::SetOptions(float *pInitAngle, float *pStepSize, int *pSegment)
{
	m_pfInitAngle = pInitAngle;
	m_pfStepSize  = pStepSize;
	m_piSegment   = pSegment;

	m_fInitAngle = *pInitAngle;
	m_fStepSize  = *pStepSize;
	m_iSegment   = *pSegment;
}

void CLSysDlg::FindRule(int index)
{
	if (index == -1) {
		for (int i=0; i<26; i++) {
			if (m_pRules[i] != "") {
				m_pszRule = m_pRules[i];
				m_cRuleList.SetCurSel(i);
				m_iCurSelRule = i;
				break;
			}
		}
	} else {
		m_pszRule = m_pRules[index];
		m_cRuleList.SetCurSel(index);	
	}

	UpdateData(false);
}

BOOL CLSysDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_iCurSelRule = -1;
	FindRule(m_iCurSelRule);
	
	return TRUE;
}

void CLSysDlg::OnSelEndOkRulelist() 
{
	UpdateData();
	m_iCurSelRule = m_cRuleList.GetCurSel();
	FindRule(m_iCurSelRule);
}

void CLSysDlg::OnChangeRule() 
{
	UpdateData();
	m_pRules[m_iCurSelRule] = m_pszRule;
}


void CLSysDlg::OnChangeName() 
{
	UpdateData();
}

void CLSysDlg::OnOK() 
{
	UpdateData();

	*m_pAxiom = m_pszAxiom;
	*m_piSegment = m_iSegment;
	*m_pfAngle = m_fAngle;
	*m_pfInitAngle = m_fInitAngle;
	*m_pfStepSize = m_fStepSize;
	*m_pName = m_pszName;
	
	CDialog::OnOK();
}
