// OptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Lse.h"
#include "OptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog


COptionsDlg::COptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionsDlg)
	m_iMouseDepth = 0;
	m_bWheel = FALSE;
	m_bPropOnLoad = FALSE;
	//}}AFX_DATA_INIT
}


void COptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDlg)
	DDX_Text(pDX, IDC_MOUSEDEPTH, m_iMouseDepth);
	DDV_MinMaxUInt(pDX, m_iMouseDepth, 0, 100);
	DDX_Check(pDX, IDC_MOUSEWHEEL, m_bWheel);
	DDX_Check(pDX, IDC_PROPLOAD, m_bPropOnLoad);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDlg, CDialog)
	//{{AFX_MSG_MAP(COptionsDlg)
	ON_BN_CLICKED(IDC_MOUSEWHEEL, OnMouseWheel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg message handlers

BOOL COptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_cBackground.SubclassDlgItem(IDC_BACKGROUND, this);
	m_cLine.SubclassDlgItem(IDC_LINE, this);
	m_cLine2.SubclassDlgItem(IDC_LINE2, this);

	CWinApp *app = AfxGetApp();

	int r,g,b;
	r = app->GetProfileInt("Settings", "LineR", 255);
	g = app->GetProfileInt("Settings", "LineG", 255);
	b = app->GetProfileInt("Settings", "LineB", 255);

	m_cLine.currentcolor = RGB(r,g,b);

	r = app->GetProfileInt("Settings", "Line2R", 255);
	g = app->GetProfileInt("Settings", "Line2G", 255);
	b = app->GetProfileInt("Settings", "Line2B", 255);

	m_cLine2.currentcolor = RGB(r,g,b);

	r = app->GetProfileInt("Settings", "BackR", 0);
	g = app->GetProfileInt("Settings", "BackG", 0);
	b = app->GetProfileInt("Settings", "BackB", 0);

	m_cBackground.currentcolor = RGB(r,g,b);

	m_iMouseDepth = app->GetProfileInt("Settings", "MouseDepth", 5);
	m_bWheel = app->GetProfileInt("Settings", "WheelEnable", 0);
	m_bPropOnLoad = app->GetProfileInt("Settings", "PropOnLoad", 0);

	UpdateData(false);
	OnMouseWheel();						// Enables or disables related controls

	return TRUE;
}

void COptionsDlg::GetColours(COLORREF &line, COLORREF &line2, COLORREF &back) 
{
	line = m_cLine.currentcolor;
	line2 = m_cLine2.currentcolor;
	back = m_cBackground.currentcolor;
}

void COptionsDlg::OnOK() 
{
	UpdateData();

	CWinApp *app = AfxGetApp();

	app->WriteProfileInt("Settings", "PropOnLoad", m_bPropOnLoad);
	app->WriteProfileInt("Settings", "WheelEnable", m_bWheel);
	app->WriteProfileInt("Settings", "MouseDepth", m_iMouseDepth);
	
	CDialog::OnOK();
}

void COptionsDlg::OnMouseWheel() 
{
	UpdateData();
	
	if (m_bWheel) {
		GetDlgItem(IDC_MDSTATIC)->EnableWindow(true);
		GetDlgItem(IDC_MOUSEDEPTH)->EnableWindow(true);
	} else {
		GetDlgItem(IDC_MDSTATIC)->EnableWindow(false);
		GetDlgItem(IDC_MOUSEDEPTH)->EnableWindow(false);
	}
}
